//+------------------------------------------------------------------+
//|                                               DoublecciWoody.mq4 |
//|
//+------------------------------------------------------------------+
#property copyright " DoublecciWoody."
#property link      "DoublecciWoody"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 MediumSeaGreen   //Green
#property indicator_color2 Red   //SaddleBrown
#property indicator_color3 DarkGray
#property indicator_color4 Gold
#property indicator_color5 DarkKhaki //White
#property indicator_color6 White  //Magenta
#property indicator_color7 DarkKhaki  //Gold  <<<<<<<<<<<<<<<<<<<<<<<<<<
#property indicator_level1 350
#property indicator_level2 250
#property indicator_level3 100
#property indicator_level4 0
#property indicator_level5 -100
#property indicator_level6 -250
#property indicator_level7 -350
//#property indicator_level8 -50

//---- input parameters
extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int             TrendCCI_Period = 14;//14
extern int             EntryCCI_Period = 6;//6
extern int             Trend_period = 2;//6
extern int             CountBars=1000; 
extern bool            Zero_Cross_Alert;
extern bool            ShowArrows          = true;
extern bool            arrowsOnFirst       = false;
extern string          arrowsIdentifier    = "cci Arrows1";
extern double          arrowsUpperGap      = 0.5;
extern double          arrowsLowerGap      = 0.5;
extern color           arrowsUpColor       = LimeGreen;
extern color           arrowsDnColor       = Red;
extern int             arrowsUpCode        = 225;
extern int             arrowsDnCode        = 226;
extern int             arrowsUpSize        = 2;
extern int             arrowsDnSize        = 2;
extern bool            verticalLinesVisible= false;
extern bool            linesOnFirst        = true;
extern string          verticalLinesID     = "cci Lines";
extern color           linesUpColor        = DeepSkyBlue;
extern color           linesDnColor        = PaleVioletRed;
extern ENUM_LINE_STYLE linesStyle          = STYLE_DOT;
extern int             linesWidth          = 0;

extern int   LineSize1=0;
extern int   LineSize2=0;
extern int   LineSize3=0;//1


double TrendCCI[];
double EntryCCI[];
double CCITrendUp[];
double CCITrendDown[];
double CCINoTrend[];
double CCITimeBar[];
double ZeroLine[];
double trend[];

int trendUp, trendDown;
string indicatorFileName;
bool   returnBars;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()  {
   arrowsIdentifier = StringConcatenate("dcci_Arrows2_",StrRand(6));
   IndicatorBuffers(8);
   SetIndexStyle(4, DRAW_LINE, STYLE_SOLID,LineSize1);
   SetIndexBuffer(4, TrendCCI);
   SetIndexLabel(4, "TrendCCI");
   SetIndexStyle(0, DRAW_HISTOGRAM, 0,LineSize1);//2
   SetIndexBuffer(0, CCITrendUp);
   SetIndexStyle(1, DRAW_HISTOGRAM, 0,LineSize1);//2
   SetIndexBuffer(1, CCITrendDown);
   SetIndexStyle(2, DRAW_HISTOGRAM, 0,LineSize2);
   SetIndexBuffer(2, CCINoTrend);
   SetIndexStyle(3, DRAW_HISTOGRAM, 0,LineSize2);
   SetIndexBuffer(3, CCITimeBar);
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID,LineSize2);// 1 <<<<<<<<<<<<<<<<<<<<<<<<<<<
   SetIndexBuffer(5, EntryCCI);
   SetIndexLabel(5, "EntryCCI");
   SetIndexStyle(6, DRAW_LINE, STYLE_SOLID,LineSize3);
   SetIndexBuffer(6, ZeroLine);
   SetIndexBuffer(7, trend);
   SetIndexLabel(7, "Trend"); 
   indicatorFileName = WindowExpertName();
   returnBars        = (TimeFrame==-99);
   TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" (TrendCCI: "+TrendCCI_Period+",EntryCCI: "+EntryCCI_Period+") ");  
return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   deleteArrows();
   deleteLines();
return(0); 
} 
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()    
{
int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { CCITrendUp[0] = limit+1; return(0); }
   
            if (TimeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,TimeFrame,Time[i]);   
                      CCITrendUp[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,ShowArrows,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,verticalLinesVisible,linesOnFirst,verticalLinesID,linesUpColor,linesDnColor,linesStyle,linesWidth,0,y);
                      CCITrendDown[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,ShowArrows,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,verticalLinesVisible,linesOnFirst,verticalLinesID,linesUpColor,linesDnColor,linesStyle,linesWidth,1,y);
                      CCINoTrend[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,ShowArrows,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,verticalLinesVisible,linesOnFirst,verticalLinesID,linesUpColor,linesDnColor,linesStyle,linesWidth,2,y);
                      CCITimeBar[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,ShowArrows,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,verticalLinesVisible,linesOnFirst,verticalLinesID,linesUpColor,linesDnColor,linesStyle,linesWidth,3,y);
                      TrendCCI[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,ShowArrows,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,verticalLinesVisible,linesOnFirst,verticalLinesID,linesUpColor,linesDnColor,linesStyle,linesWidth,4,y);
                      EntryCCI[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,ShowArrows,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,verticalLinesVisible,linesOnFirst,verticalLinesID,linesUpColor,linesDnColor,linesStyle,linesWidth,5,y);
                      ZeroLine[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,TrendCCI_Period,EntryCCI_Period,Trend_period,CountBars,Zero_Cross_Alert,ShowArrows,arrowsOnFirst,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,verticalLinesVisible,linesOnFirst,verticalLinesID,linesUpColor,linesDnColor,linesStyle,linesWidth,6,y);
               }
               return(0);
            }
static datetime prevtime = 0;
   counted_bars = IndicatorCounted();
//---- check for possible errors
   
     SetIndexDrawBegin(0,Bars-CountBars);
     SetIndexDrawBegin(1,Bars-CountBars);
     SetIndexDrawBegin(2,Bars-CountBars);
     SetIndexDrawBegin(3,Bars-CountBars);
     SetIndexDrawBegin(4,Bars-CountBars);
     SetIndexDrawBegin(5,Bars-CountBars);
     SetIndexDrawBegin(6,Bars-CountBars);
   
   for(i = limit; i >= 0; i--) {
      CCINoTrend[i] = 0;
      CCITrendDown[i] = 0;
      CCITimeBar[i] = 0;
      CCITrendUp[i] = 0;
      ZeroLine[i] = 0;
      TrendCCI[i] = iCCI(NULL, 0, TrendCCI_Period, PRICE_TYPICAL, i);
      EntryCCI[i] = iCCI(NULL, 0, EntryCCI_Period, PRICE_TYPICAL, i);
      
      if(TrendCCI[i] > 0 && TrendCCI[i+1] < 0) {
         if (trendDown >  Trend_period) trendUp = 0;
      }
      if (TrendCCI[i] > 0) {
         if (trendUp <  Trend_period){
            CCINoTrend[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp ==  Trend_period) {
            CCITimeBar[i] = TrendCCI[i];
            trendUp++;
         }
         if (trendUp >  Trend_period) {
            CCITrendUp[i] = TrendCCI[i];
         }
      }
      if(TrendCCI[i] < 0 && TrendCCI[i+1] > 0) {
         if (trendUp >  Trend_period) trendDown = 0;
      }
      if (TrendCCI[i] < 0) {
         
         if (trendDown <  Trend_period){
            CCINoTrend[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown ==  Trend_period) {
            CCITimeBar[i] = TrendCCI[i];
            trendDown++;
         }
         if (trendDown >  Trend_period) {
            CCITrendDown[i] = TrendCCI[i];
         }
      }
      trend[i] = 0;
      if (EntryCCI[i]>ZeroLine[i]) trend[i] = 1;
      if (EntryCCI[i]<ZeroLine[i]) trend[i] =-1;
      
      //
         //
         //
         //
         //
         
         if (ShowArrows)
         {
            deleteArrow(Time[i]);
            if (trend[i]!=trend[i+1])
            {
               if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
               if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode,arrowsDnSize, true);
            }
         }
         
         //
         //
         //
         //
         //
         
         if (verticalLinesVisible)
         {
            deleteLine(Time[i]);
            if (trend[i]!= trend[i+1])
            {
               if (trend[i] == 1) drawLine(i,linesUpColor);
               if (trend[i] ==-1) drawLine(i,linesDnColor);
            }
         }
         
   }
   
   if (Zero_Cross_Alert == true) {
      if (prevtime == Time[0]) {
         return(0);
      }
      else {
         if(EntryCCI[0] < 0) {
            if((TrendCCI[0] < 0) && (TrendCCI[1] >= 0)) {
               Alert(Symbol(), " M", Period(), " Trend & Entry CCI Have both crossed below zero");
            }
         }
         else if(EntryCCI[0] > 0) {
            if((TrendCCI[0] > 0) && (TrendCCI[1] <= 0)) {
               Alert(Symbol(), " M", Period(), " Trend & Entry CCI Have both crossed above zero");
            }
         }
         prevtime = Time[0];
      }
   }
//---- 
   
//----
   return(0);
  }
//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theWidth,bool tup)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!arrowsOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (tup)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+ arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//
//

void drawLine(int i,color theColor)
{
      string name = verticalLinesID+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!linesOnFirst) add = _Period*60-1;
      ObjectCreate(name,OBJ_VLINE,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,linesStyle);
         ObjectSet(name,OBJPROP_WIDTH,linesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//

void deleteLines()
{
   string lookFor       = verticalLinesID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteLine(datetime time)
{
   string lookFor = verticalLinesID+":"+time; ObjectDelete(lookFor);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf) {
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


string StrRand(int length)
{
   string output = "";
   int num; 
   
   for(int i=0;i<length;i++) {
      num = 25*rand()/32768+97;
     
      output = StringConcatenate(output,CharToStr((uchar)num));
   }
   
   return(output);
}